﻿namespace WarmlyShip.CollectionGenericObjects;

public class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    
    private T?[] _collection;

    public int Count => _collection.Length;

    public int MaxCount
    {
        get
        {
            return _collection.Length;
        }
        set
        {
            if (value > 0)
            {
                if (Count > 0)
                {
                    Array.Resize(ref _collection, value);
                }
                else
                {
                    _collection = new T?[value];
                }
            }
        }
    }

    
    public MassiveGenericObjects()
    {
        _collection = Array.Empty<T?>();
    }

    public CollectionType GetCollectionType => CollectionType.Massive;

    public T? Get(int position)
    {
        // TODO проверка позиции
        if (position < 0 || position > Count)
        {
            return null;
        }

        return _collection[position];
    }

    public int Insert(T obj)
    {
        // TODO вставка в свободное место набора
        for (int i = 0; i < Count; i++)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }

        return -1;
    }

    public int Insert(T obj, int position)
    {
        // TODO проверка позиции
        // TODO проверка, что элемент массима по этой позиции пустой,
        // если элемент массима по этой позиции не пустой,
        // найти свободное место после этой позиции, если не найдено,
        // то искать до
        // TODO вставка
        if (position < 0 || position >= Count)
        {
            return -1;
        }

        if (_collection[position] == null)
        {
            _collection[position] = obj;
            return position;
        }
        else
        {
            for (int i = position + 1; i < Count; i++)
            {
                if (_collection[i] == null)
                {
                    _collection[i] = obj;
                    return i;
                }
            }

            for (int i = position; i >= 0; i--)
            {
                if (_collection[i] == null)
                {
                    _collection[i] = obj;
                    return i;
                }
            }
        }

        return -1;
    }

    public T Remove(int position)
    {
        // TODO проверка позиции
        // TODO удаление объекта из массива,
        // присвоив элементу массива значение null
        if (position >= Count || position < 0)
        {
            return null;
        }

        T obj = _collection[position];
        _collection[position] = null;
        return obj;
    }
    public IEnumerable<T?> GetItems()
    {
        for (int i = 0; i < _collection.Length; i++)
        {
            yield return _collection[i];
        }
    }
}
