﻿using WarmlyShip.CollectionGenericObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WarmlyShip.Drawnings;

namespace WarmlyShip.CollectionGenericObjects
{
    public class PortForShips : AbstractCompany
    {
        public PortForShips(int picWidth, int picHeight, ICollectionGenericObjects<DrawningShip> collection) : base(picWidth, picHeight, collection)
        {
        }
        protected override void DrawBackgroud(Graphics g)
        {
            int _placeWidth = _placeSizeWidth + _placeSizeWidth / 2;
            int _placeHeight = _placeSizeHeight;
            for (int x = 2; x < _pictureWidth - _placeSizeWidth; x += _placeWidth)
            {
                for (int y = 2; y < _pictureHeight - _placeSizeHeight; y += _placeHeight)
                {
                    Pen pen = new Pen(Color.Black, 3);
                    Point[] points =
                    {
                    new Point(x + _placeSizeWidth, y),
                    new Point(x, y),
                    new Point(x, y + _placeSizeHeight),
                    new Point(x + _placeSizeWidth, y + _placeSizeHeight)
                };
                    g.DrawLines(pen, points);
                }
            }
        }

        protected override void SetObjectPosition()
        {
            int countOfHorizontal = _pictureWidth / (_placeSizeWidth + _placeSizeWidth / 2);
            int countOfVertical = _pictureHeight / _placeSizeHeight;

            int countW = 0;
            int countH = 0;

            for (int i = 0; i < _collection.Count; i++)
            {

                if (countW == 4)
                {
                    countW = 0;
                    countH++;
                }
                if (_collection.Get(i) != null)
                {
                    
                    _collection.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);

                    _collection.Get(i)?.SetPosition((_placeSizeWidth + _placeSizeWidth / 2) * (countOfHorizontal -  countW - 1) + 5, _placeSizeHeight * countH + 5);
                    
                }
                countW++;
            }
        }
    }
}
