﻿using WarmlyShip.Entities;

namespace WarmlyShip.Drawnings;

public static class ExtensionDrawningShip
{
    
    private static readonly string _separatorForObject = ":";


    public static DrawningShip? CreateDrawningShip(this string info)
    {
        string[] strs = info.Split(_separatorForObject);

        EntityShip? ship = EntityWarmlyShip.CreateEntityWarmlyShip(strs);
        if (ship != null)
        {
            return new DrawningWarmlyShip((EntityWarmlyShip)ship);
        }

        ship = EntityShip.CreateEntityShip(strs);
        if (ship != null)
        {
            return new DrawningShip(ship);
        }

        return null;
    }

    public static string GetDataForSave(this DrawningShip drawningShip)
    {
        string[]? array = drawningShip?.EntityShip?.GetStringRepresentation();

        if (array == null)
        {
            return string.Empty;
        }

        return string.Join(_separatorForObject, array);
    }
}
