﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip.Entities;

public class EntityShip
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }

    public void setBodyColor(Color color)
    {
        BodyColor = color;
    }

    public double Step => Speed * 100 / Weight;


    public EntityShip (int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;

    }
    public virtual string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityShip), Speed.ToString(), Weight.ToString(), BodyColor.Name };
    }

   
    public static EntityShip? CreateEntityShip(string[] strs)
    {
        if (strs.Length != 4 || strs[0] != nameof(EntityShip))
        {
            return null;
        }

        return new EntityShip(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]));
    }
    
}
