﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip.Entities;

public class EntityWarmlyShip : EntityShip
{
 
    /// <summary>
    /// доп. цвет
    /// </summary>
 

    public Color SeckondColor { get; set; }

    public void setSeckondColor(Color color)
    {
        SeckondColor = color;
    }

    /// <summary>
    /// признак наличия отсека для топлива
    /// </summary>
    public bool FuelHole { get; private set; }

    /// <summary>
    /// Признак наличия трубы
    /// </summary>
    public bool Pipes { get; private set; }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="speed"> скорость </param>
    /// <param name="weight">вес</param>
    /// <param name="bodyColor">основной цвет</param>
    /// <param name="seckondColor">доп. цвет</param>
    /// <param name="fuelHole">признак наличия отсека для топлива</param>
    /// <param name="pipes">признак наличия трубы</param>
    public EntityWarmlyShip (int speed, double weight, Color bodyColor, Color seckondColor, bool fuelHole, bool pipes) : base (speed, weight, bodyColor)
    {
        
        SeckondColor = seckondColor;
        FuelHole = fuelHole;
        Pipes = pipes;

    }
    public virtual string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityShip), Speed.ToString(), Weight.ToString(), BodyColor.Name,
            SeckondColor.Name, FuelHole.ToString(), Pipes.ToString() };
    }


    public static EntityShip? CreateEntityWarmlyShip(string[] strs)
    {
        if (strs.Length != 7 || strs[0] != nameof(EntityShip))
        {
            return null;
        }

        return new EntityWarmlyShip(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]),
            Color.FromName(strs[4]), Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
    }
}
